#用列表表示三根柱子，最前面的1号柱从小到大放着一些圆盘
p=[[1,2,3],[],[]]
#变量steps保存操作步骤
steps=[]

# 从起始位置，移到动目标位置
def move(origin,goal):
    #获得起始列表最前面的元素，并从起始列表中删除
    disk=p[origin].pop(0)
    #把圆盘保存到目标列表的最前面
    p[goal].insert(0,disk)
    #记录操作步骤
    steps.append(f'把{disk}号盘从{origin+1}号柱子移到{goal+1}号柱子。')

#递归调用的函数
def hanno (n,start , end , temp) :
    if n == 1 :
        move(start,end)
    elif n > 1:
        hanno(n - 1, start, temp, end)
        move(start,end)
        hanno(n - 1, temp, end, start)

#展示操作过程
def display():
    for step in steps:  print(step)


#递归调用求解，可描述为利用过渡柱把n个盘从起始柱移到目标柱
hanno(len(p[0]),0,2,1)
display()
